> For the complete documentation index, see [llms.txt](https://docs.dynalogic.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.dynalogic.com/birds-document-warehouse-product-overview/integrations-and-technical-reference/d365-finance-and-operations.md).

# D365 Finance & Operations

## Code snippets

### 1. Tag selector

With this code snippet, It Is possible to open the tag field selector dialog from a formdatasource extension.

```
[ExtensionOf(formDataSourceStr(form, formdatasource))]
public final class Form_FormDataSource_FDS_CustomerModel_Extension
{
    public void init()
    {
        EXADocuTagSelectorExtensionOverrides docuTagSelectorExtensionOverrides;
        ;
 
        next init();
        docuTagSelectorExtensionOverrides = EXADocuTagSelectorExtensionOverrides::construct();
        docuTagSelectorExtensionOverrides.common = this.cursor();
        docuTagSelectorExtensionOverrides.documentTagFieldId = fieldNum(Table, FieldTag);
 
        this.object(fieldNum(Table, FieldTag)).registerOverrideMethod(  methodstr(FormStringControl, lookup),                                                                        methodStr(EXADocuTagSelectorExtensionOverrides, documentTag_OnLookup),                                                                        
        docuTagSelectorExtensionOverrides);
    }
}
```

### 2. HTTP request - production order attachments

Here's an example on how to pass a documentId from the Document Warehouse to D365FO for a production order:

· <https://d365fo-environment.cloudax.dynamics.com/data/EXAProdTableAttachments>

· HTTP verb: POST

· Body: JSON

Example JSON body

```
{
"dataAreaId": "FRRT", to find it in the tags of your document
"TypeId": "DOC_WAREHOUSE", // depends from customer to customer
"Name": "document.pdf",
"FileName": "document",
"FileType":"pdf",
"ProdId":"000006", // to find it in the tags of your document
"EXADocumentId": "d739d37a-77c9-44c7-b822-715a06f95752" // documentId of document in Document Warehouse
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.dynalogic.com/birds-document-warehouse-product-overview/integrations-and-technical-reference/d365-finance-and-operations.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
